<?php

namespace Importacao\Logic\Bases\ModeloImportacao;

use Folha\Entities\GpeOcupacaom;
use Folha\Entities\MigOcupacaom;
use Folha\Entities\MigAlteocupacao;
use Geral\Entities\Base\Logprojimport;
use Geral\Util\DateUtil;
use Setforms2\Runtime\Logger;

class EntityBuilder {

    const PADRAO_SET = 'set';

    private $data;

    public function __construct($data = array())
    {
        $this->data = $data;
    }

    /**
     *
     */
    public function buildGrupos()
    {
        // variável para identificar se existe erro na validação
        $existeErro = false;

        $i = 1;
        \Setforms2\Shared\Registry::getEntityManager()->beginTransaction();

        foreach ($this->data as $key => $entity) {
            $nrlinha = round(($key + 2) / 2);
            $tablename = \Importacao\Logic\Util\Util::normalizeNameClass($entity->getTableName());

            $className = "\\Folha\\Entities\\".$tablename;
            $table = new $className();

            // contador de quantos error foram identificados
            $countError = 0;
            foreach ($entity->getFields() as $fieldName => $fieldValue) {
                try {
                    $fieldName = $this->normaliseNameField($fieldName);
                    $table->$fieldName(trim($fieldValue));
                    $table->setNrprojimport(\Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->getNrprojimport());
                } catch (\Exception $e) {
                    $msg = $e->getMessage();
                    if (!empty($msg)) {
                        \Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->criaLogDeItemProjeto(null, $e->getMessage(), $nrlinha, null, \Geral\Entities\Logprojimport::VALIDACAO_INTEGRIDADE);
                        $countError++;
                        $existeErro = true;
                    }
                }
            }

            // persiste os dados na entidade, se o contador de error for igual a zero ele persite o registro na entidade
            if ($countError == 0) {
                $table->persist();
            }

            if ($i % 1 === 0 || $i == count($this->data)) {
                \Setforms2\Shared\Registry::getEntityManager()->flush();
                \Setforms2\Shared\Registry::getEntityManager()->commit();
                \Setforms2\Shared\Registry::getEntityManager()->beginTransaction();
                $i = 0;
            }

            $i++;
        }

        // atualiza se a validação foi executada COM erros ou SEM erros.
        $this->validacaoStatus($existeErro);
    }
//    public function buildGrupos()
//    {
//        // variável para identificar se existe erro na validação
//        $existeErro = false;
//
//        foreach ($this->data as $key => $entity) {
//
//            $nrlinha = round(($key + 2) / 2);
//            $tablename = \Importacao\Logic\Util\Util::normalizeNameClass($entity->getTableName());
//
//            $className = "\\Folha\\Entities\\".$tablename;
//            $table = new $className();
//
//            // contador de quantos error foram identificados
//            $countError = 0;
//            foreach ($entity->getFields() as $fieldName => $fieldValue) {
//                try {
//                    $fieldName = $this->normaliseNameField($fieldName);
//                    $table->$fieldName(trim($fieldValue));
//                    $table->setNrprojimport(\Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->getNrprojimport());
//                } catch (\Exception $e) {
//                    $msg = $e->getMessage();
//                    if (!empty($msg)) {
//                        \Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->criaLogDeItemProjeto(null, $e->getMessage(), $nrlinha, null, \Geral\Entities\Logprojimport::VALIDACAO_INTEGRIDADE);
//                        $countError++;
//                        $existeErro = true;
//                    }
//                }
//            }
//
//            // persiste os dados na entidade, se o contador de error for igual a zero ele persite o registro na entidade
//            if ($countError == 0) {
//                \Setforms2\Shared\Registry::getEntityManager()->beginTransaction();
//                $table->persist();
//                \Setforms2\Shared\Registry::getEntityManager()->commit();
//            }
//
//            \Setforms2\Shared\Registry::getEntityManager()->flush();
//        }
//
//        // atualiza se a validação foi executada COM erros ou SEM erros.
//        $this->validacaoStatus($existeErro);
//    }

    /**
     * @param $fieldName
     * @return string
     */
    public function normaliseNameField($fieldName)
    {
        return self::PADRAO_SET.ucfirst(strtolower($fieldName));
    }

    /**
     * @param $existeErro
     */
    public function validacaoStatus($existeErro)
    {
        if ($existeErro) {
            \Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->atualizaPercentStatus("Validação com erros");
        } else {
            \Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->atualizaPercentStatus("Validação sem erros");
        }
    }

}