/* Tabela GRUPOFISCAL: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela GRUPOFISCAL */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela GRUPOFISCAL utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_NUMERORNF
AFTER DELETE OR INSERT OR UPDATE
ON NUMERORNF FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);

  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);

  V_DTOPER       DATE;
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';
   
   IF DELETING THEN
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CodFil=' || :OLD.CDFILIAL;
      END IF;

      IF :OLD.DTNUMERNF IS NOT NULL THEN
         V_DESC := V_DESC || ' DtRnf=' || :OLD.DTNUMERNF;
      END IF;

      IF :OLD.NRNUMERNF IS NOT NULL THEN
         V_DESC := V_DESC || ' NrRnf=' || :OLD.NRNUMERNF;
      END IF;

      IF :OLD.IDENTRSAID IS NOT NULL THEN
         V_DESC := V_DESC || ' EntrSaid=' || :OLD.IDENTRSAID;
      END IF;

      IF :OLD.IDTIPOOPERNF IS NOT NULL THEN
         V_DESC := V_DESC || ' IdTipoOper=' || :OLD.IDTIPOOPERNF;
      END IF;

      V_TIPO         := '3';
      V_CDFILLOGOPER := :OLD.CDFILIAL;
      V_ITPESQ       := :OLD.CDFILIAL||:OLD.DTNUMERNF||:OLD.IDENTRSAID||:OLD.IDTIPOOPERNF||:OLD.NRNUMERNF;
   ELSE
      IF UPDATING THEN
         IF NVL(:NEW.CDFILIAL,'!')          <>  NVL(:OLD.CDFILIAL,'!')       OR
            NVL(:NEW.DTNUMERNF, SYSDATE)    <>  NVL(:OLD.DTNUMERNF,SYSDATE)  OR
            NVL(:NEW.NRNUMERNF,'!')         <>  NVL(:OLD.NRNUMERNF,'!')      OR
            NVL(:NEW.IDENTRSAID,'!')        <>  NVL(:OLD.IDENTRSAID,'!')     OR
            NVL(:NEW.IDTIPOOPERNF,'!')      <>  NVL(:OLD.IDTIPOOPERNF,'!')  THEN

            IF NVL(:NEW.CDFILIAL,'!') <>  NVL(:OLD.CDFILIAL,'!')  THEN
               V_DESC := V_DESC || 'CodFil=' || :NEW.CDFILIAL;
            END IF;

            IF NVL(:NEW.DTNUMERNF,SYSDATE) <>  NVL(:OLD.DTNUMERNF,SYSDATE)  THEN
               V_DESC := V_DESC || ' DtRnf=' || :NEW.DTNUMERNF;
            END IF;

            IF NVL(:NEW.NRNUMERNF,'!') <>  NVL(:OLD.NRNUMERNF,'!')  THEN
               V_DESC := V_DESC || ' NrRnf=' || :NEW.NRNUMERNF;
            END IF;

            IF NVL(:NEW.IDENTRSAID,'!') <>  NVL(:OLD.IDENTRSAID,'!')  THEN
               V_DESC := V_DESC || ' EntrSaid=' || :NEW.IDENTRSAID;
            END IF;

            IF NVL(:NEW.IDTIPOOPERNF,'!') <>  NVL(:OLD.IDTIPOOPERNF,'!')  THEN
               V_DESC := V_DESC || ' IdTipoOper=' || :NEW.IDTIPOOPERNF;
            END IF;

            V_TIPO         := '2';
            V_CDFILLOGOPER := :OLD.CDFILIAL;            
            V_ITPESQ       := :OLD.CDFILIAL||:OLD.DTNUMERNF||:OLD.IDENTRSAID||:OLD.IDTIPOOPERNF||:OLD.NRNUMERNF;
         END IF;
      ELSE
         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'CodFil=' || :NEW.CDFILIAL;
         END IF;

         IF :NEW.DTNUMERNF IS NOT NULL THEN
            V_DESC := V_DESC || ' DtRnf=' || :NEW.DTNUMERNF;
         END IF;

         IF :NEW.NRNUMERNF IS NOT NULL THEN
            V_DESC := V_DESC || ' NrRnf=' || :NEW.NRNUMERNF;
         END IF;

         IF :NEW.IDENTRSAID IS NOT NULL THEN
            V_DESC := V_DESC || ' EntrSaid=' || :NEW.IDENTRSAID;
         END IF;

         IF :NEW.IDTIPOOPERNF IS NOT NULL THEN
            V_DESC := V_DESC || ' IdTipoOper=' || :NEW.IDTIPOOPERNF;
         END IF;
         V_TIPO         := '1';
         V_CDFILLOGOPER := :NEW.CDFILIAL;
         V_ITPESQ       := :NEW.CDFILIAL||:NEW.DTNUMERNF||:NEW.IDENTRSAID||:NEW.IDTIPOOPERNF||:NEW.NRNUMERNF;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('NUMERORNF',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_NUMERORNF','4.09.060'); END;
/

