/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_PARADIETO                                                */
/* Tabela : PARADIETO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                           		         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PARADIETO'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
  DROP TRIGGER DTULTATU_PARADIETO
  GO


CREATE TRIGGER DTULTATU_PARADIETO
ON PARADIETO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'PARADIETO', '', 'CDPARADIETO='+CDPARADIETO+';',GETDATE()                                  FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PARADIETO
      SET DTULTATUPDIE = GETDATE()
      FROM INSERTED
      WHERE
         (PARADIETO.CDPARADIETO = INSERTED.CDPARADIETO)
   END;
END;
GO

